﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfDatabindingExampleCS
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window, INotifyPropertyChanged
    {

        private string _textBoxText;

        public string TextBoxText
        {
            get
            {
                return _textBoxText;
            }
            set
            {
                if (_textBoxText == value)
                    return;
                _textBoxText = value;
                NotifyOfPropertyChange();
            }
        }

        private bool _checkBoxBool;

        public bool CheckBoxBool
        {
            get
            {
                return _checkBoxBool;
            }
            set
            {
                if (_checkBoxBool == value)
                    return;
                _checkBoxBool = value;
                NotifyOfPropertyChange();
            }
        }

        public ObservableCollection<Customer> Customers { get; set; }

        public MainWindow()
        {
            InitializeComponent();
            DataContext = this;
            PrepareCustomers();
        }

        private void PrepareCustomers()
        {
            Customers = new ObservableCollection<Customer>();
            Customers.Add(new Customer("John", "Doe"));
            Customers.Add(new Customer("Maximilian", "Doe"));
            Customers.Add(new Customer("Robert", "Doe"));
        }

        private void NotifyOfPropertyChange([CallerMemberName] string propertyName = null)
        {
            if (propertyName == null)
                return;
            PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        public event PropertyChangedEventHandler PropertyChanged;

    }
}
